// DisasmEngine.cpp : implementation file
//
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "stdafx.h"
#include "disasm.h"
#include "DisasmEngine.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDisasmEngine

CDisasmEngine::CDisasmEngine()
{
	byte_end=big_endian;
	byte_order=flipped;
}

CDisasmEngine::~CDisasmEngine()
{
}


BEGIN_MESSAGE_MAP(CDisasmEngine, CWnd)
	//{{AFX_MSG_MAP(CDisasmEngine)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CDisasmEngine message handlers





unsigned short int CDisasmEngine::get_bits_31_29(char *buff,int pos)
{   return(((unsigned short)buff[0+pos+off0]&224)>>5);
}

unsigned short int CDisasmEngine::get_bits_28_26(char *buff,int pos)
{   return(((unsigned short)buff[0+pos+off0]&28)>>2);
}
unsigned short int CDisasmEngine::get_bits_5_3(char *buff,int pos)
{
    return(((unsigned short)buff[3+pos+off3]&56)>>3);
}
unsigned short int CDisasmEngine::get_bits_2_0(char *buff,int pos)
{
    return(((unsigned short)buff[3+pos+off3]&7));
}
unsigned long CDisasmEngine::get_bits_25_0(char *buff,int pos)
{
    return( (((unsigned long)(buff[0+pos+off0]&3))<<24) |
             ((((unsigned long)buff[1+pos+off1])&0xff)<<16)   |
             ((((unsigned long)buff[2+pos+off2])&0xff)<<8)     |
             (((unsigned long)buff[3+pos+off3])&0xff)           );
}
unsigned short int CDisasmEngine::get_bits_25_21(char *buff,int pos)
{
    return( (((unsigned short)buff[0+pos+off0]&3)<<3) |
                (((unsigned short)buff[1+pos+off1]&224)>>5)   );
}
unsigned short int CDisasmEngine::get_bits_20_16(char *buff,int pos)
{
    return( (((unsigned short)buff[1+pos+off1]&31)) );

}
unsigned short int CDisasmEngine::get_bits_15_11(char *buff,int pos)
{
    return( (((unsigned short)buff[2+pos+off2]&248)>>3) );

}

unsigned short int CDisasmEngine::get_bits_15_0(char *buff,int pos)
{
    return( ((unsigned short) buff[2+pos+off2]<<8) |
                (((unsigned short) buff[3+pos+off3])&0xff) );
}

unsigned short CDisasmEngine::get_bits_10_6(char *buff,int pos)
{
    return( ((((unsigned short) buff[2+pos+off2])&7)<<2)|
             ((((unsigned short) buff[3+pos+off3])&(128+64))>>6)  );
}
unsigned short int CDisasmEngine::get_bits_20_19(char *buff,int pos)
{
    return( (((unsigned short)buff[1+pos+off1]&24)>>3) );

}
unsigned short int CDisasmEngine::get_bits_18_16(char *buff,int pos)
{
    return( (((unsigned short)buff[1+pos+off1]&7)) );

}


BYTE CDisasmEngine::GetByte(DWORD offset,LPSTR buff)
{
		if(byte_end==big_endian&&byte_order==not_flipped)
	{
			return(buff[offset]);
	

	}
	if(byte_end==big_endian&&byte_order==flipped)
	{
		if(offset%2)
			return(buff[offset-1]);
		else
			return(buff[offset+1]);
			
	}
if(byte_end==little_endian&&byte_order==not_flipped)
	{
		switch(offset%4)
		{
		case(0):
			return(buff[offset+3]);
		case(1):
			return(buff[offset+1]);
		case(2):
			return(buff[offset-1]);
		case(3):
			return(buff[offset-3]);
		}

		
	}
if(byte_end==little_endian&&byte_order==flipped)
	{
		switch(offset%4)
		{
		case(0):
			return(buff[offset+2]);
		case(1):
			return(buff[offset+2]);
		case(2):
			return(buff[offset-2]);
		case(3):
			return(buff[offset-2]);
		}
	}

return(buff[offset]);


	



}


              
             


LPSTR CDisasmEngine::GetLine(DWORD offset,LPSTR buff,DWORD romsize,int Code_Extract)
{  	 
	char *nem[8][8]=
        {"special","regimm","j","jal","beq","bne","blez","bgtz", 
        "addi","addiu","slti","sltiu","andi","ori","xori","lui",
        "cop0","cop1","cop2",0,"beql","bnel","blezl","bgtzl",
        "daddi","daddiu","ldl","ldr",0,0,0,0,        
        "lb","lh","lwl","lw","lbu","lhu","lwr","lwu",
        "sb","sh","swl","sw","sdl","sdr","swr","cache",
        "ll","lwc1","lwc2",0,"lld","ldc1","ldc2","ld",
        "sc","swc1","swc2",0,"scd","sdc1","sdc2","sd"};

  int nem_mode[8][8]={0,0,2,2,4,4,5,5,
                      4,4,4,4,4,4,4,10,
                      0,0,0,-1,4,4,5,5,
                      4,4,4,4,-1,-1,-1,-1,
                      4,4,4,4,4,4,4,4,
                      4,4,4,4,4,4,4,0,
                      4,4,4,-1,4,4,4,4,
                      4,4,4,-1,4,4,4,4};


      
    //    4,4,4,
    //special[bits 5..3][bits 2..0] of 'special table page a-181'
    char *special[8][8]=
        {"sll",0,"srl","sra","sllv",0,"srlv","srav",
        "jr","jalr",0,0,"syscall","break",0,"sync",
        "mfhi","mthi","mflo","mtlo","dsllv",0,"dsrlv","dsrav",
        "mult","multu","div","divu","dmult","dmultu","ddiv","ddivu",
        "add","addu","sub","subu","and","or","xor","nor",
        0,0,"slt","sltu","dadd","daddu","dsub","dsubu",
        "tge","tgeu","tlt","tltu","teq",0,"tne",0,
        "dsll",0,"dsrl","dsra","dsll32",0,"dsrl32","dsra32"};

    int special_mode[8][8]=
        {7,-1,7,7,3,-1,3,3,
         9,8,-1,-1,0,0,-1,0,
         11,12,11,12,3,-1,3,3,
         6,6,6,6,6,6,6,6,
         3,3,3,3,3,3,3,3,
         -1,-1,3,4,3,3,3,3,
         6,6,6,6,6,-1,6,-1,
         7,-1,7,7,7,-1,7,7};
            

       

    //regimm[bits 20..19][bits 18..16] of regimm table a-181
    char *regimm[4][8]=
        {"bltz","bgez","bltzl","bgezl",0,0,0,0,
         "tgei","tgeiu","tlti","tltiu","teqi",0,"tnei",0,
         "bltzal","bgezal","bltzall","bgezall",0,0,0,0,
         0,0,0,0,0,0,0,0};
         
     int reg_mode[4][8]=
        {5,5,5,5,-1,-1,-1,-1,
        5,5,5,5,5,-1,5,-1,
        5,5,5,5,-1,-1,-1,-1,
        -1,-1,-1,-1,-1,-1,-1,-1};

    char *copzrs[2][8]=
        {"mf","dmf","cf",0,"mt","dmt","ct",0,
         "bc",0,0,0,0,0,0,0};

    char *copzrt[1][8]=
        {"bcf","bct","bcfl","bctl",0,0,0,0};

    char *cp0[4][8]=
        {0,"tlbr","tlbwi",0,0,0,"tlbwr",0,
         "tlbp",0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,
         "eret",0,0,0,0,0,0,0};

	char *retval;
	char *temp1;
	char *temp2;
	int zeroflag[4];
	DWORD x;


	if(byte_end==big_endian&&byte_order==not_flipped)
	{
		off0=0;
		off1=0;
		off2=0;
		off3=0;
	}
	if(byte_end==big_endian&&byte_order==flipped)
	{
		off0=1;
		off1=-1;
		off2=1;
		off3=-1;
	}
if(byte_end==little_endian&&byte_order==not_flipped)
	{
		off0=3;
		off1=1;
		off2=-1;
		off3=-3;
	}
if(byte_end==little_endian&&byte_order==flipped)
	{
		off0=2;
		off1=2;
		off2=-2;
		off3=-2;
	}

	



	retval=new char[256];


	temp1=new char[256];
	temp2=new char[256];
	zeroflag[0]=0;
	zeroflag[1]=0;
	zeroflag[2]=0;
	zeroflag[3]=0;
	
	if(buff[0+off0+offset]==0)
		zeroflag[0]=1;
	if(buff[1+off1+offset]==0)
		zeroflag[1]=1;
	if(buff[2+off2+offset]==0)
		zeroflag[2]=1;
	if(buff[3+off3+offset]==0)
		zeroflag[3]=1;

	
	x=offset;


	
	sprintf(temp1,"0x%X:  ",offset);
	sprintf(temp2," error: %X%X%X%X",buff[0+x+off0],
						buff[1+x+off1],buff[2+x+off2]
						,buff[3+x+off3]);
		             
             switch(nem_mode[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)])
             {
                 
                 
                 case(-1):
                 {
					 sprintf(temp2,"DD '%c%c%c%c' =0x%X",buff[0+x+off0]+zeroflag[0],
						buff[1+x+off1]+zeroflag[1],buff[2+x+off2]+zeroflag[2]
						,buff[3+x+off3]+zeroflag[3],
						((((unsigned long int) buff[0+x+off0])<<24) |
						(((unsigned long int) buff[1+x+off1])<<16) |
                        (((unsigned long int) buff[2+x+off2])<<8) |
                        ((unsigned long int) buff[3+x+off3])));
                  /*  cout<<"DD '"<<buff[0+x]<<buff[1+x]<<buff[2+x]<<buff[3+x]<<"'";
                                    cout<<" = 0x"<<hex<<((((unsigned long int) buff[0+x])<<24) |
                                                      (((unsigned long int) buff[1+x])<<16) |
                                                      (((unsigned long int) buff[2+x])<<8) |
                                                      ((unsigned long int) buff[3+x]))<<"\n";*/
                    break;
                 }

                 case(2):
                 {
					 sprintf(temp2,"%s 0x%X",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
						 get_bits_25_0(buff,x));

            //         cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<" ";
              //       cout<<" 0x"<<hex<<get_bits_25_0(buff,x)<<"\n";
                     break;
                 }

                 case(3):
                 {

					 sprintf(temp2,"%s rd %d, rs %d,rt %d",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
						 get_bits_15_11(buff,x),get_bits_25_21(buff,x),get_bits_20_16(buff,x));
					 
                //     cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<" rd "<<
                  //   get_bits_15_11(buff,x)<<",rs "<<get_bits_25_21(buff,x)<<",rt "<<
                    // get_bits_20_16(buff,x)<<"\n";
                     
                     
                     break;
                 }
                 case(4):
                 {

				 sprintf(temp2,"%s rt %d, rs %d, 0x%X=%hi",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
					  get_bits_20_16(buff,x),get_bits_25_21(buff,x),
					   get_bits_15_0(buff,x),get_bits_15_0(buff,x));

//                     cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<" rt "<<
  //                    get_bits_20_16(buff,x)<<",rs "<<get_bits_25_21(buff,x)<<",";
    //                  cout<<" 0x"<<hex<<get_bits_15_0(buff,x);
      //                cout<<" = "<<dec<<(signed short)get_bits_15_0(buff,x)<<"\n";
                      break;
                 }

                 case(5):
                 {
					 
	 				 sprintf(temp2,"%s rs %d, 0x%X = %d ",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
					 get_bits_25_21(buff,x),get_bits_15_0(buff,x),get_bits_15_0(buff,x));

//                     cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<" rs "<<
  //                   get_bits_25_21(buff,x)<<",";
    //                  cout<<" 0x"<<hex<<get_bits_15_0(buff,x);
      //                cout<<" = "<<dec<<(signed short)get_bits_15_0(buff,x)<<"\n";
                      break;
                 }
                 

                 case(6):
                 {
					 sprintf(temp2,"%s rt %d,rs %d ",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
						get_bits_20_16(buff,x),get_bits_25_21(buff,x));

                     //cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<" rt "<<
            //          get_bits_20_16(buff,x)<<",rs "<<get_bits_25_21(buff,x);

                      break;
                 }

                 case(7):
                 {
					 sprintf(temp2,"%s rd %d, rt %d, %d",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
						  get_bits_15_11(buff,x),get_bits_20_16(buff,x),get_bits_10_6(buff,x));
                     
                      //cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<" rd "<<
              //        get_bits_15_11(buff,x)<<",rt "<< get_bits_20_16(buff,x)<<", "<<
                //      get_bits_10_6(buff,x)<<"\n";

                      break;
                 }
                 case(8):
                 {
					 sprintf(temp2,"%s rd %d, rs %d",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
						  get_bits_15_11(buff,x),get_bits_25_21(buff,x));
                     //cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<" rd "<<
                  //   get_bits_15_11(buff,x)<<",rs "<<get_bits_25_21(buff,x)<<"\n";
                     break;
                 }

                 case(9):
                 {
         			 sprintf(temp2,"%s rs %d",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
						get_bits_25_21(buff,x));
	            //cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<
//                     ",rs "<<get_bits_25_21(buff,x)<<"\n";
                     break;
                 }

                 case(10):
                 {
         			 sprintf(temp2,"%s rt %d, 0x%X",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
						  get_bits_20_16(buff,x),get_bits_15_0(buff,x));

  //                   //cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<
    //                 " rt "<< get_bits_20_16(buff,x)<<", ";
                     //cout<<hex<<"0x"<<get_bits_15_0(buff,x)<<"\n";
                     break;
                 }

                 case(11):
                 {
         			 sprintf(temp2,"%s rd %d",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
						get_bits_15_11(buff,x));
                     //cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<
      //               ",rd "<<get_bits_15_11(buff,x)<<"\n";
                     break;
                 }

                 case(12):
                 {
         			 sprintf(temp2,"%s rs %d",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)],
						  get_bits_25_21(buff,x));

                     //cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<dec<<
        //             ",rs "<<get_bits_25_21(buff,x)<<"\n";
                     break;
                 }

                 case(0):
                 {
                     switch(get_bits_31_29(buff,x)+get_bits_28_26(buff,x))
                     {
                         case(0):
                         {
                             switch(special_mode[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)])
                             {
                                 
                                 case(-1):
                                 {
									 sprintf(temp2,"DD '%c%c%c%c' =0x%X",buff[0+x+off0]+zeroflag[0],
									 buff[1+x+off1]+zeroflag[1],buff[2+x+off2]+zeroflag[2]
									 ,buff[3+x+off3]+zeroflag[3],
									 ((((unsigned long int) buff[0+x+off0])<<24) |
									 (((unsigned long int) buff[1+x+off1])<<16) |
									 (((unsigned long int) buff[2+x+off2])<<8) |
									 ((unsigned long int) buff[3+x+off3])));
                                    //cout<<"DD '"<<buff[0+x]<<buff[1+x]<<buff[2+x]<<buff[3+x]<<"'";
          //                          //cout<<" = 0x"<<hex<<((((unsigned long int) buff[0+x])<<24) |
            //                                          (((unsigned long int) buff[1+x])<<16) |
              //                                        (((unsigned long int) buff[2+x])<<8) |
                //                                      ((unsigned long int) buff[3+x]))<<"\n";
                                    break;
                                 }

                                 case(2):
                                 {
			 			 sprintf(temp2,"%s 0x%X",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
						 get_bits_25_0(buff,x));

                                     //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<" ";
                                     //cout<<" 0x"<<hex<<get_bits_25_0(buff,x)<<"\n";
                                     break;
                                 }

                                 case(3):
                                 {
					 	 sprintf(temp2,"%s rd %d, rs %d,rt %d",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
						 get_bits_15_11(buff,x),get_bits_25_21(buff,x),get_bits_20_16(buff,x));
			
                                     //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<" rd "<<
                  //                   get_bits_15_11(buff,x)<<",rs "<<get_bits_25_21(buff,x)<<",rt "<<
                    //                 get_bits_20_16(buff,x)<<"\n";
                     
                     
                                     break;
                                 }
                                 case(4):
                                 {


					 sprintf(temp2,"%s rt %d, rs %d, 0x%X=%d",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
					  get_bits_20_16(buff,x),get_bits_25_21(buff,x),
					   get_bits_15_0(buff,x),get_bits_15_0(buff,x));

                                     //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<" rt "<<
                      //                get_bits_20_16(buff,x)<<",rs "<<get_bits_25_21(buff,x)<<",";
                                      //cout<<" 0x"<<hex<<get_bits_15_0(buff,x);
                                      //cout<<" = "<<dec<<(signed short)get_bits_15_0(buff,x)<<"\n";
                                      break;
                                 }
        
                                 case(5):
                                 {
 	 				 sprintf(temp2,"%s rs %d, 0x%X = %d ",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
					 get_bits_25_21(buff,x),get_bits_15_0(buff,x),get_bits_15_0(buff,x));

                                     //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<" rs "<<
                        //             get_bits_25_21(buff,x)<<",";
                                      //cout<<" 0x"<<hex<<get_bits_15_0(buff,x);
                                      //cout<<" = "<<dec<<(signed short)get_bits_15_0(buff,x)<<"\n";
                                      break;
                                 }
                 

                                 case(6):
  								{
						 sprintf(temp2,"%s rt %d,rs %d ",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
						get_bits_20_16(buff,x),get_bits_25_21(buff,x));
                               
                                     //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<" rt "<<
                          //            get_bits_20_16(buff,x)<<",rs "<<get_bits_25_21(buff,x)<<"\n";

                                      break;
                                 }

                                 case(7):
                                 {
                     
     					 sprintf(temp2,"%s rd %d, rt %d, %d",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
						  get_bits_15_11(buff,x),get_bits_20_16(buff,x),get_bits_10_6(buff,x));
                                 //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<" rd "<<
                            //          get_bits_15_11(buff,x)<<",rt "<< get_bits_20_16(buff,x)<<", "<<
                              //        get_bits_10_6(buff,x)<<"\n";

                                      break;
                                 }
                                 case(8):
                                 {
           				 sprintf(temp2,"%s rd %d, rs %d",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
						  get_bits_15_11(buff,x),get_bits_25_21(buff,x));
                           //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<" rd "<<
//                                     get_bits_15_11(buff,x)<<",rs "<<get_bits_25_21(buff,x)<<"\n";
                                     break;
                                 }

                                 case(9):
                                 {
                 		 sprintf(temp2,"%s rs %d",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
						get_bits_25_21(buff,x));
                          //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<
  //                                   ",rs "<<get_bits_25_21(buff,x)<<"\n";
                                     break;
                                 }

                                 case(10):
                                 {


        			 sprintf(temp2,"%s rt %d, 0x%X",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
						  get_bits_20_16(buff,x),get_bits_15_0(buff,x));

    //                                 //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<
      //                               ",rt "<< get_bits_20_16(buff,x)<<", ";
                                     //cout<<hex<<"0x"<<get_bits_15_0(buff,x)<<"\n";
                                     break;
                                 }

                                 case(11):
                                 {
     			 sprintf(temp2,"%s rd %d",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
						get_bits_15_11(buff,x));
   
        //                             //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<
          //                           ",rd "<<get_bits_15_11(buff,x)<<"\n";
                                     break;
                                 }

                                 case(12):
                                 {
    			 sprintf(temp2,"%s rs %d",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)],
						  get_bits_25_21(buff,x));

                                     //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<dec<<
            //                         ",rs "<<get_bits_25_21(buff,x)<<"\n";
                                     break;
                                 }
                     
                                 default:
                                 {
									sprintf(temp2,"%s",special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]);
                                      //cout<<special[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)]<<"\n";
                                      break;
                                 }
                             }//end switch for special

                             break;

                         }//end for case0 is special

                         case(1): //case 1 for regimm ops  only type 5 and -1
                         {
                               if(reg_mode[get_bits_20_19(buff,x)][get_bits_18_16(buff,x)]==5)
                               {
   	 				 sprintf(temp2,"%s rs %d, 0x%X = %d ",regimm[get_bits_20_19(buff,x)][get_bits_18_16(buff,x)],
					 get_bits_25_21(buff,x),get_bits_15_0(buff,x),get_bits_15_0(buff,x));

                                     //cout<<regimm[get_bits_20_19(buff,x)][get_bits_18_16(buff,x)]<<dec<<" rs "<<
//                                     get_bits_25_21(buff,x)<<",";
                                      //cout<<" 0x"<<hex<<get_bits_15_0(buff,x);
                                      //cout<<" = "<<dec<<(signed short)get_bits_15_0(buff,x)<<"\n";
                               }
                               else
                               {
   									 sprintf(temp2,"DD '%c%c%c%c' =0x%X",buff[0+x+off0]+zeroflag[0],
									 buff[1+x+off1]+zeroflag[1],buff[2+x+off2]+zeroflag[2]
									 ,buff[3+x+off3]+zeroflag[3],
									 ((((unsigned long int) buff[0+x+off0])<<24) |
									 (((unsigned long int) buff[1+x+off1])<<16) |
									 (((unsigned long int) buff[2+x+off2])<<8) |
									 ((unsigned long int) buff[3+x+off3])));

								   
								   //cout<<"DD '"<<buff[0+x]<<buff[1+x]<<buff[2+x]<<buff[3+x]<<"'";
                                    //cout<<" = 0x"<<hex<<((((unsigned long int) buff[0+x])<<24) |
              //                                        (((unsigned long int) buff[1+x])<<16) |
                //                                      (((unsigned long int) buff[2+x])<<8) |
                  //                                    ((unsigned long int) buff[3+x]))<<"\n";
                               }
                               break;
                         }
                                
                                
                  

                         default:
                         {		 sprintf(temp2,"%s",nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]);
                             //cout<<nem[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)]<<"\n";
                             break;
                         }

                     }


                     break;


                 }

             



                 
             }


if((Code_Extract==1)&&(CodeExtract(x,buff,romsize)==0))
{
	sprintf(temp2,"DD '%c%c%c%c' =0x%X",buff[0+x+off0]+zeroflag[0],
	buff[1+x+off1]+zeroflag[1],buff[2+x+off2]+zeroflag[2]
	,buff[3+x+off3]+zeroflag[3],
	((((unsigned long int) buff[0+x+off0])<<24) |
	(((unsigned long int) buff[1+x+off1])<<16) |
    (((unsigned long int) buff[2+x+off2])<<8) |
    ((unsigned long int) buff[3+x+off3])));
}                   
                     
                 
              strcat(temp1,temp2);
		
			  strcpy(retval,temp1);
			  delete [] temp1;
			  delete[]  temp2;
			  return(retval);
             


}
int CDisasmEngine::CodeExtract(DWORD offset,LPSTR buff,DWORD size)
{
	DWORD x,y;

	if(DatJump(offset,buff)==-1)
	return(1);

	for(x=offset;x<size;x+=4)
	{if(DatJump(x,buff)==0)
		break;
	}

	for(y=x;y>offset;y-=4)
	{
		if(DatJump(y,buff)==-1)
			return(1);
	}

	return(0);
}

















int CDisasmEngine::DatJump(DWORD offset,LPSTR buff)
{  	 
	char *nem[8][8]=
        {"special","regimm","j","jal","beq","bne","blez","bgtz", 
        "addi","addiu","slti","sltiu","andi","ori","xori","lui",
        "cop0","cop1","cop2",0,"beql","bnel","blezl","bgtzl",
        "daddi","daddiu","ldl","ldr",0,0,0,0,        
        "lb","lh","lwl","lw","lbu","lhu","lwr","lwu",
        "sb","sh","swl","sw","sdl","sdr","swr","cache",
        "ll","lwc1","lwc2",0,"lld","ldc1","ldc2","ld",
        "sc","swc1","swc2",0,"scd","sdc1","sdc2","sd"};

  int nem_mode[8][8]={0,0,20,20,20,20,20,20,
                      4,4,4,4,4,4,4,10,
                      0,0,0,-1,20,20,20,20,
                      4,4,4,4,-1,-1,-1,-1,
                      4,4,4,4,4,4,4,4,
                      4,4,4,4,4,4,4,0,
                      4,4,4,-1,4,4,4,4,
                      4,4,4,-1,4,4,4,4};


      
    //    4,4,4,
    //special[bits 5..3][bits 2..0] of 'special table page a-181'
    char *special[8][8]=
        {"sll",0,"srl","sra","sllv",0,"srlv","srav",
        "jr","jalr",0,0,"syscall","break",0,"sync",
        "mfhi","mthi","mflo","mtlo","dsllv",0,"dsrlv","dsrav",
        "mult","multu","div","divu","dmult","dmultu","ddiv","ddivu",
        "add","addu","sub","subu","and","or","xor","nor",
        0,0,"slt","sltu","dadd","daddu","dsub","dsubu",
        "tge","tgeu","tlt","tltu","teq",0,"tne",0,
        "dsll",0,"dsrl","dsra","dsll32",0,"dsrl32","dsra32"};

    int special_mode[8][8]=
        {7,-1,7,7,3,-1,3,3,
         20,20,-1,-1,20,20,-1,0,
         11,12,11,12,3,-1,3,3,
         6,6,6,6,6,6,6,6,
         3,3,3,3,3,3,3,3,
         -1,-1,3,4,3,3,3,3,
         20,20,20,20,20,-1,20,-1,
         7,-1,7,7,7,-1,7,7};
            

       

    //regimm[bits 20..19][bits 18..16] of regimm table a-181
    char *regimm[4][8]=
        {"bltz","bgez","bltzl","bgezl",0,0,0,0,
         "tgei","tgeiu","tlti","tltiu","teqi",0,"tnei",0,
         "bltzal","bgezal","bltzall","bgezall",0,0,0,0,
         0,0,0,0,0,0,0,0};
         
     int reg_mode[4][8]=
        {5,5,5,5,-1,-1,-1,-1,
        5,5,5,5,5,-1,5,-1,
        5,5,5,5,-1,-1,-1,-1,
        -1,-1,-1,-1,-1,-1,-1,-1};

    char *copzrs[2][8]=
        {"mf","dmf","cf",0,"mt","dmt","ct",0,
         "bc",0,0,0,0,0,0,0};

    char *copzrt[1][8]=
        {"bcf","bct","bcfl","bctl",0,0,0,0};

    char *cp0[4][8]=
        {0,"tlbr","tlbwi",0,0,0,"tlbwr",0,
         "tlbp",0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,
         "eret",0,0,0,0,0,0,0};


	DWORD x;

	if(byte_end==big_endian&&byte_order==not_flipped)
	{
		off0=0;
		off1=0;
		off2=0;
		off3=0;
	}
	if(byte_end==big_endian&&byte_order==flipped)
	{
		off0=1;
		off1=-1;
		off2=1;
		off3=-1;
	}
if(byte_end==little_endian&&byte_order==not_flipped)
	{
		off0=3;
		off1=1;
		off2=-1;
		off3=-3;
	}
if(byte_end==little_endian&&byte_order==flipped)
	{
		off0=2;
		off1=2;
		off2=-2;
		off3=-2;
	}

	





	
	x=offset;



             
             switch(nem_mode[get_bits_31_29(buff,x)][get_bits_28_26(buff,x)])
             {
                 case(-1):
                 {
					return(0);
				    break;
                 }
                case(20):
                 {
					return(-1);
				    break;
                 }
			     case(0):
                 {
                     switch(get_bits_31_29(buff,x)+get_bits_28_26(buff,x))
                     {
                         case(0):
                         {
                             switch(special_mode[get_bits_5_3(buff,x)][get_bits_2_0(buff,x)])
                             {
                                 
                                 case(-1):
                                 {
									return(0);
                                    break;
                                 }
				                 case(20):
								 {
									return(-1);
									break;
								 }

                                 default:
                                 {
									 return(1);
                                     break;
                                 }
                             }//end switch for special

                             break;

                         }//end for case0 is special

                         case(1): //case 1 for regimm ops  only type 5 and -1
                         {
                               if(reg_mode[get_bits_20_19(buff,x)][get_bits_18_16(buff,x)]==5)
                               {
								   return(1);
   	 			
                               }
                               else
                               {
   								return(0);
                               }
                               break;
                         }
                                
                                
                  

                         default:
                         {
							 return(1);
                             break;
                         }

                     }
                

                     break;


                 }

                default:
                   {
					 return(1);
                      break;
                   }




                 
             }

                     
                     
                 


}
