// disasmDoc.cpp : implementation of the CDisasmDoc class
//

#include "stdafx.h"
#include "disasm.h"
#include "DisasmEngine.h"
#include "disasmDoc.h"
#include  <string.h>
#include "offsetdlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDisasmDoc

IMPLEMENT_DYNCREATE(CDisasmDoc, CDocument)

BEGIN_MESSAGE_MAP(CDisasmDoc, CDocument)
	//{{AFX_MSG_MAP(CDisasmDoc)
	ON_COMMAND(ID_BYTEORDERING_BIG_ENDIAN, OnByteorderingBigEndian)
	ON_COMMAND(ID_BYTEORDERING_FLIPBYTESWITHINWORDS, OnByteorderingFlipbyteswithinwords)
	ON_COMMAND(ID_BYTEORDERING_LITTLEENDIAN, OnByteorderingLittleendian)
	ON_UPDATE_COMMAND_UI(ID_BYTEORDERING_BIG_ENDIAN, OnUpdateByteorderingBigEndian)
	ON_UPDATE_COMMAND_UI(ID_BYTEORDERING_FLIPBYTESWITHINWORDS, OnUpdateByteorderingFlipbyteswithinwords)
	ON_UPDATE_COMMAND_UI(ID_BYTEORDERING_LITTLEENDIAN, OnUpdateByteorderingLittleendian)
	ON_COMMAND(ID_DATAEXTRACTION_ACTIVE, OnDataextractionActive)
	ON_UPDATE_COMMAND_UI(ID_DATAEXTRACTION_ACTIVE, OnUpdateDataextractionActive)
	ON_COMMAND(ID_VIEW_GOTOOFFSET, OnViewGotooffset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisasmDoc construction/destruction

CDisasmDoc::CDisasmDoc()
{
	romhandle=0;
	current_rom_position=0;
	byte_end=big_endian;
	byte_order=flipped;
	Code_Extract=0;

}

CDisasmDoc::~CDisasmDoc()
{
	if(romhandle)
		delete [] romhandle;
		
}

BOOL CDisasmDoc::OnNewDocument()
{
//	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

//	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDisasmDoc serialization

void CDisasmDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDisasmDoc diagnostics

#ifdef _DEBUG
void CDisasmDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDisasmDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDisasmDoc commands


LPSTR CDisasmDoc::GetData(DWORD line)
{

CDisasmEngine mydisasm;
mydisasm.byte_order=byte_order;
mydisasm.byte_end=byte_end;


//4 bytes per line (disassemble format)
if(romhandle)
return(mydisasm.GetLine(line*4,romhandle,romsize,Code_Extract));
else
return(0);
}

BYTE CDisasmDoc::GetByte(DWORD offs)
{
	CDisasmEngine mydisasm;
	mydisasm.byte_order=byte_order;
	mydisasm.byte_end=byte_end;

	if(romhandle)
	return(mydisasm.GetByte(offs+current_rom_position*4,romhandle));
	else
	return(0);
}


BOOL CDisasmDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
     CFile myfile;
     DWORD size_of_file;
     
     
	
	
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
     

	if(!myfile.Open(lpszPathName,CFile::modeRead|CFile::typeBinary))
		return(FALSE);

	myfile.Seek(0,CFile::begin);
	size_of_file=myfile.GetLength();

	romhandle=new char [size_of_file];

	romsize=myfile.Read(romhandle,size_of_file);

	myfile.Close();

	return(TRUE);


	
    
}

void CDisasmDoc::OnByteorderingBigEndian() 
{

	byte_end=big_endian;
	this->UpdateAllViews(NULL);
	
}

void CDisasmDoc::OnByteorderingFlipbyteswithinwords() 
{
	
	byte_order^=1;
	this->UpdateAllViews(NULL);
}

void CDisasmDoc::OnByteorderingLittleendian() 
{
	
	byte_end=little_endian;
	this->UpdateAllViews(NULL);
}

void CDisasmDoc::OnUpdateByteorderingBigEndian(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(byte_end==big_endian);
	
}

void CDisasmDoc::OnUpdateByteorderingFlipbyteswithinwords(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(byte_order==flipped);

	
}

void CDisasmDoc::OnUpdateByteorderingLittleendian(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(byte_end==little_endian);
	
}

void CDisasmDoc::OnDataextractionActive() 
{

		Code_Extract^=1;
		this->UpdateAllViews(NULL);


}

void CDisasmDoc::OnUpdateDataextractionActive(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(Code_Extract==1);
	
}

void CDisasmDoc::OnViewGotooffset() 
{
	offset_dlg_handle=new COffsetDlg;
	offset_dlg_handle->parent_doc=this;
	offset_dlg_handle->DoModal();

	if(offset_dlg_handle)
		delete offset_dlg_handle;

	
}
